# Copyright (C) 2021, KylinSoft Co., Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import os
import sys

arg_lang = ""

################################
# 常量

# for get_env_lang()
STR_GET_ENV_LANG_ZH     = "语言环境为中文"
STR_GET_ENV_LANG_EN     = "语言环境为英文"
STR_GET_ENV_LANG_UNKNOW = "语言环境未知"

# for is_root()
STR_IS_ROOT_TRUE  = "当前用户为root权限"
STR_IS_ROOT_FALSE = "当前用户没有root权限"

################################
# 环境检查函数

def get_env_lang():
#    lang = os.getenv("LANG")
#    if lang.startswith("zh"):
#        return STR_GET_ENV_LANG_ZH
#    elif lang.startswith("en"):
#        return STR_GET_ENV_LANG_EN
#    else:
#        return STR_GET_ENV_LANG_UNKNOW
#
    if arg_lang == "zh":
        return STR_GET_ENV_LANG_ZH
    elif arg_lang == "en":
        return STR_GET_ENV_LANG_EN
    else:
        return STR_GET_ENV_LANG_UNKNOW

def is_root():
    if os.geteuid() == 0:
        print(STR_IS_ROOT_TRUE)
        return True
    else:
        print(STR_IS_ROOT_FALSE)
        return False

################################
# 辅助函数
def l_print(zh_str, en_str) :
    if STR_GET_ENV_LANG_ZH == get_env_lang() :
        print(zh_str);
    else :
        print(en_str);

################################
# 功能函数

# 检查文件权限是否正确配置
def check_file_permission(filepath, mode):
    if os.path.exists(filepath):
        if oct(os.stat(filepath).st_mode)[-3:] == mode:
            l_print(f"[OK] 通过文件权限检查: {filepath}",
                    f"[OK] File permission check passed for {filepath}")
        else:
            l_print(f"[WARNING] 文件权限配置不正确: {filepath}",
                    f"[WARNING] Incorrect file permission detected for {filepath}")
    else:
        l_print(f"[OK] 文件未找到: {filepath}",
                f"[OK] File not found for {filepath}")

if __name__ == '__main__':
    arg_lang = sys.argv[1]
    # 文件权限检查
    check_file_permission("/etc/crontab", "644")
    check_file_permission("/etc/cron.d", "755")
    check_file_permission("/etc/cron.hourly", "755")
    check_file_permission("/etc/cron.daily", "755")
    check_file_permission("/etc/cron.weekly", "755")
    check_file_permission("/etc/cron.monthly", "755")
