# Copyright (C) 2021, KylinSoft Co., Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import pytest
import os
from BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port import get_env_lang,is_root,arg_lang,l_print,check_high_risk_port
from BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port_631 import check_cups_risk_port
from BaseLine.LocalServices.highRiskPort.check_high_risk_port.fix_high_risk_port import fix_high_risk_port
from BaseLine.LocalServices.highRiskPort.check_high_risk_port.fix_high_risk_port_631 import fix_631
def test_get_env_lang(monkeypatch):
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", 'en')
    assert get_env_lang() == "语言环境为英文"
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", 'zh')
    assert get_env_lang() == "语言环境为中文"
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", '')
    assert get_env_lang() == "语言环境未知"
def test_is_root(monkeypatch):
    if os.geteuid() == 0:
        assert is_root() == True
    else:
        assert is_root() == False
def test_l_print(monkeypatch, capsys):
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", 'zh')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "zh\n"
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", 'en')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
    monkeypatch.setattr("BaseLine.LocalServices.highRiskPort.check_high_risk_port.check_high_risk_port.arg_lang", '')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
def test_check_high_risk_port(capsys):
    check_high_risk_port("127.0.0.1")
    captured = capsys.readouterr()
    assert f"[OK] High risk port" in captured.out
def test_check_cups_risk_port(capsys):
    port = 631
    check_cups_risk_port(port)
    captured = capsys.readouterr()
    assert captured.out == f"[OK] High risk port {port} don't open\n"
def test_fix_high_risk_port(capsys):
    fix_high_risk_port("21")
    captured = capsys.readouterr()
    assert "fix pass" in captured.out
def test_fix_631(capsys):
    fix_631()
    captured = capsys.readouterr()
    assert "[OK] 631 fix suff" in captured.out