# Copyright (C) 2021, KylinSoft Co., Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import pytest
import os
from BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout import get_env_lang,is_root,arg_lang,l_print,check_ssh_login_timeout
from BaseLine.RemoteServices.ssh.check_ssh_login_timeout.fix_ssh_login_timeout import fix_ssh_login_timeout
def test_get_env_lang(monkeypatch):
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", 'en')
    assert get_env_lang() == "语言环境为英文"
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", 'zh')
    assert get_env_lang() == "语言环境为中文"
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", '')
    assert get_env_lang() == "语言环境未知"
def test_is_root(monkeypatch):
    if os.geteuid() == 0:
        assert is_root() == True
    else:
        assert is_root() == False
def test_l_print(monkeypatch, capsys):
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", 'zh')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "zh\n"
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", 'en')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
    monkeypatch.setattr("BaseLine.RemoteServices.ssh.check_ssh_login_timeout.check_ssh_login_timeout.arg_lang", '')
    l_print("zh","en")
    captured = capsys.readouterr()
    assert captured.out == "en\n"
def test_check_ssh_login_timeout(capsys):
    check_ssh_login_timeout()
    captured = capsys.readouterr()
    assert "[OK] SSH login timeout not configured check passed" in captured.out
def test_fix_ssh_login_timeout(capsys):
    fix_ssh_login_timeout()
    captured = capsys.readouterr()
    assert "[OK] fix suff" in captured.out